﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace RegExThaiCreate
{
    class Program
    {
        static void Main(string[] args)
        {
            var haystacks = new[]
                                {
                                    "13:02:59.55",
                                    "9:15:59.10",
                                    "03:52:59.99abc",
                                    "03:42:59.100",
                                    "23-12:59.01",
                                    "33:12:49.00",
                                    "00:11:59.00",
                                    "24-34:59.00",
                                    "11z35:59.00",
                                    "22:30:59.00",
                                };
                        
            var patterns = @"^([1-9]|(0|1)[0-9]|(2)[0-3]):([0-5][0-9]):([0-5][0-9]).([0-9][0-9])\z";
            Regex rx = new Regex(patterns, RegexOptions.IgnoreCase);

            Console.WriteLine("IsMatch\r\n=======");
            foreach (var haystack in haystacks)
            {
                if(rx.IsMatch(haystack))
                {
                    Console.WriteLine("{0} matches our pattern.", haystack);
                }                
            }
            Console.WriteLine();
            Console.WriteLine();

            Console.WriteLine("Matches\r\n=======");            
            var patternsWithNames = @"(?<hour>^([1-9]|(0|1)[0-9]|(2)[0-3])):(?<minute>([0-5][0-9])):(?<second>([0-5][0-9])).(?<centisecond>([0-9][0-9])\z)";
            Regex rx2 = new Regex(patternsWithNames, RegexOptions.IgnoreCase);
            foreach (var haystack in haystacks)
            {
                MatchCollection matchCollection = rx2.Matches(haystack);

                if (matchCollection.Count > 0)
                {
                    foreach (Match match in matchCollection)
                    {
                        Console.WriteLine("{0} matches our pattern.", haystack);
                        Console.WriteLine("hour: {0}", Int32.Parse(match.Groups["hour"].ToString()));
                        Console.WriteLine("minute: {0}", Int32.Parse(match.Groups["minute"].ToString()));
                        Console.WriteLine("second: {0}", Int32.Parse(match.Groups["second"].ToString()));
                        Console.WriteLine("centisecond: {0}", Int32.Parse(match.Groups["centisecond"].ToString()));
                        Console.WriteLine();
                    }
                }
            }
            
        }
    }
}
